diff -ur orig/zaptel-1.2.7/zaptel.c zaptel-1.2.7/zaptel.c
--- orig/zaptel-1.2.7/zaptel.c	2006-08-18 18:32:56.467220536 -0400
+++ zaptel-1.2.7/zaptel.c	2006-08-18 18:33:55.153298896 -0400
@@ -1971,7 +1971,7 @@
 		return -EINVAL;
 
 	chan->kewlonhook = 0;
-
+	chan->kewlnewcall = 0;
 
 	if ((chan->sig == ZT_SIG_FXSLS) || (chan->sig == ZT_SIG_FXSKS) ||
 		(chan->sig == ZT_SIG_FXSGS)) chan->ringdebtimer = RING_DEBOUNCE_TIME;
@@ -5159,6 +5159,14 @@
 		break;
 
 	case ZT_TXSTATE_AFTERKEWL:
+		if (chan->kewlnewcall) {
+			printk("Detected new call (channel %d) in TXSTATE_AFTERKEWL, hanging up again\n", chan->channo);
+			chan->kewlnewcall = 0;
+			zt_rbs_sethook(chan, ZT_TXSIG_KEWL, ZT_TXSTATE_KEWL, ZT_KEWLTIME);
+			wake_up_interruptible(&chan->txstateq);
+			break;
+		}
+
 		if (chan->kewlonhook)  {
 			__qevent(chan,ZT_EVENT_ONHOOK);
 		}
@@ -5299,6 +5307,7 @@
 				zt_rbs_sethook(chan,ZT_TXSIG_OFFHOOK, ZT_TXSTATE_AFTERSTART, ZT_AFTERSTART_TIME);
 			}
 			chan->kewlonhook = 0;
+			chan->kewlnewcall = 1;
 #ifdef CONFIG_ZAPATA_DEBUG
 			printk("Off hook on channel %d, itimer = %d, gotgs = %d\n", chan->channo, chan->itimer, chan->gotgs);
 #endif
@@ -5334,8 +5343,10 @@
 			    (chan->txstate != ZT_TXSTATE_AFTERKEWL)) {
 				chan->itimerset = chan->itimer = chan->rxflashtime * ZT_CHUNKSIZE;
 			}
-			if (chan->txstate == ZT_TXSTATE_KEWL)
+			if (chan->txstate == ZT_TXSTATE_KEWL) {
 				chan->kewlonhook = 1;
+				chan->kewlnewcall = 0;
+			}
 			break;
 		    default:
 			break;
diff -ur orig/zaptel-1.2.7/zaptel.h zaptel-1.2.7/zaptel.h
--- orig/zaptel-1.2.7/zaptel.h	2005-12-16 21:04:05.000000000 -0500
+++ zaptel-1.2.7/zaptel.h	2006-08-18 18:32:15.072513488 -0400
@@ -1172,6 +1172,7 @@
 	int rxhooksig;
 	int txhooksig;
 	int kewlonhook;
+	int kewlnewcall;
 
 	/* Idle signalling if CAS signalling */
 	int idlebits;
